///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CXMLReader_H_
#define _CXMLReader_H_
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CXMLReader {

public:

	CXMLReader::CXMLReader(const char *sXML, const int iXMLSz, bool bCompressed);
	CXMLReader::CXMLReader(const char *sXML, const int iXMLSz);
	CXMLReader::CXMLReader(const char *sXML);
	CXMLReader::CXMLReader(void);
	CXMLReader::~CXMLReader(void);

	char *Text(void);
	int Text(char *sTarget, int iMaxSz);
	int Length(void);

	bool Initialize(const char *sXML);
	bool Initialize(const char *sXML, const int iXMLSz);
	CXMLReader *SetPointer(const char *sXML, const int iXMLSz); //For low-level use.
	CXMLReader *SetPointer(const char *sXML); //For low-level use.
	bool Destroy(void);

	double ToDouble(const char *sTag);
	int ToInteger(const char *sTag);
	__int64 ToI64(const char *sTag);
	bool ToInteger(const char *sTag, int *iOutValue);
	bool ToI64(const char *sTag, __int64 *i64OutValue);
	bool ToDouble(const char *sTag, double *dOutValue);
	bool ToBoolean(const char *sTag, bool *bOutValue);
	bool ToBoolean(const char *sTag, bool bDefaultValue);
	bool ToBoolean(const char *sTag);
	int ToString(const char *sTag, char *sOutAttrib, int iMaxSz);
	int ToString(const char *sTag, char *sOutAttrib, int iMaxSz, const char *sDefaultValue);
	bool ToString(const char *sTag, char *sOutAttrib, int iMaxSz, const char *sDefaultValue, int *iReturnLength);
	bool ToString(const char *sTag, char *sOutAttrib, int iMaxSz, int *iReturnLength);
	unsigned int ToUInteger(const char *sTag);
	bool ToUInteger(const char *sTag, unsigned int *uiOutValue);
	bool ToUInteger(const char *sTag, DWORD *uiOutValue);
	bool ToReader(const char *sTag, CXMLReader *lpXMLReader);
	bool ToReader(const char *sTag, const int iTag, CXMLReader *lpXMLReader);
	bool ToFile(const char *sFileName);

	int ToInteger(const char *sTag, int iDefaultValue);
	unsigned int ToUInteger(const char *sTag, unsigned int uiDefaultValue);
	__int64 ToI64(const char *sTag, __int64 i64DefaultValue);
	double ToDouble(const char *sTag, double dDefaultValue);

	bool FromFile(const char *sFileName);
	int AttributeLength(const char *sTag);
	bool ProgressiveScan(bool bEnable);

protected:
	char *sOriginalXML;
	int iOriginalXMLSz;
	bool bProgressiveScan;
	int iScanPosition;
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
