///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CXMLWriter_H_
#define _CXMLWriter_H_
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../../@Classes/CStringBuilder/CStringBuilder.H"

#include "CXMLReader.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CXMLWriter {

public:
	CXMLWriter::CXMLWriter(const char *sChildName);
	CXMLWriter::CXMLWriter(void);
	CXMLWriter::~CXMLWriter(void);

	bool Initialize(void);
	bool Initialize(const char *sChildName);
	bool ChangeName(const char *sChildName);
	int GetName(char *sOutName, int iMaxOut);
	bool Destroy(void);

	CStringBuilder *GetBuilder(void);

	CXMLReader *ToReader(CXMLReader *lpXMLReader);

	bool Add(const char *sAttributeName, const char *sValue);
	bool Add(const char *sAttributeName, const char *sValue, const int iValueSz);
	bool Add(const char *sAttributeName, const unsigned int iValue);
	bool Add(const char *sAttributeName, const DWORD dwValue);
	bool Add(const char *sAttributeName, const signed int iValue);
	bool Add(const char *sAttributeName, const double dValue);
	bool Add(const char *sAttributeName, const double dValue, const int iDecimalPlaces);
	bool Add(const char *sAttributeName, const __int64 i64Value);
	bool AddBool(const char *sAttributeName, const bool bValue);

	bool Add(const char *sAttributeName, CXMLWriter *XML);
	bool Add(const char *sAttributeName, CXMLReader *XML);

	bool Add(CXMLReader *XML);
	bool Add(CXMLWriter *XML);

	int Length(void);

	int Text(char *sOutXML, int iMaxOutSz);
	char *Text(void);
	char *Text(int *iOutSz);

#ifdef _CXML_USE_COMPRESSION
	char *Compress(int *iOutLength);
	char *Compress(int *iOutLength, int iCompressionLevel);
#endif

	bool ToFile(const char *sFileName);

protected:
	CStringBuilder *pBuilder;
	char sName[255];
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
